<%-- $Id: view_details.jsp 6621 2014-11-24 13:15:23Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg
	Copyright (C) 2007 Johan Enell

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.DiskUsage"
	import="net.sf.basedb.core.DiskUsageStatistics"
	import="net.sf.basedb.core.DiskConsumable"
	import="net.sf.basedb.core.Quota"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.Removable"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.QuotaType"
	import="net.sf.basedb.core.Metadata"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Quantity"
	import="net.sf.basedb.core.Unit"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.util.units.UnitUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Map"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final String subContext = "diskUsage";
	private static final Enumeration<String, String> itemTypes = new Enumeration<String, String>();
	static
	{
		for (Item item : Metadata.getDiskConsumableItems())
		{
			itemTypes.add(String.valueOf(item.getValue()), item.toString());
		}
	}
	private static final Enumeration<String, String> locations = new Enumeration<String, String>();
	static
	{
		for (Location l : Location.values())
		{
			locations.add(String.valueOf(l.getValue()), l.toString());
		}
	}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, null, null);
final int itemId = cc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
ItemResultIterator<DiskUsage> diskUsage = null;
try
{
	Unit bytes = UnitUtil.getUnit(dc, Quantity.STORAGE_SIZE, "B");
	String title = null;
	User user = null;
	Group group = null;
	boolean writePermission = false;
	final boolean hasDiskUsagePermission = sc.hasPermission(Permission.READ, Item.DISKUSAGE);
	DiskUsageStatistics statistics = (DiskUsageStatistics)sc.getSessionSetting("diskUsageStatistics");
	String returnCmd = null;
	if (statistics == null)
	{
		statistics = DiskUsage.getStatistics(dc);
		sc.setSessionSetting("diskUsageStatistics", statistics);
	}
	statistics.setDbControl(dc);
	List<QuotaType> quotaTypes = statistics.getQuotaTypes();
	DiskUsageStatistics.Summary summary = null;
	if (itemType == Item.USER)
	{
		user = User.getById(dc, itemId);
		title = user.getName() + " (user)";
		writePermission = user.hasPermission(Permission.WRITE);
		summary = statistics.getSummary(user);
		returnCmd = "ListUsers";
	}
	else
	{
		group = Group.getById(dc, itemId);
		title = group.getName() + " (group)";
		writePermission = group.hasPermission(Permission.WRITE);
		summary = statistics.getSummary(group);
		returnCmd = "ListGroups";
	}
	long totalCount = 0;
	int numListed = 0;
	try
	{
		final ItemQuery<DiskUsage> query = Base.getConfiguredQuery(dc, cc, true, DiskUsage.getQuery(user, group), null);
		diskUsage = query.iterate(dc);
		totalCount = diskUsage.getTotalCount();
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
	}
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, 
			GuiContext.list(Item.DISKUSAGE), user == null ? group : user);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page >
	<base:head scripts="table.js,tabcontrol-2.js,~details.js" styles="toolbar.css,table.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<style>
		table.special
		{
			width: auto;
		}
		table.special td, table.special tr:first-child th
		{
			text-align: right;
			border-right-width: 1px;
			border-right-style: dotted;
		}
		</style>
	</base:head>
	<base:body>
		<p:path><p:pathelement 
			title="Disk usage" enabled="<%=hasDiskUsagePermission%>"
				href="<%="../index.jsp?ID="+ID+"&cmd="+returnCmd%>" 
			/><p:pathelement title="<%=HTML.encodeTags(title)%>" 
			/></p:path>
			
		<div id="page-data" class="datacontainer" 
			data-item-id="<%=itemId%>" data-item-type="<%=itemType.name()%>"></div>
		
		<t:tabcontrol id="main" 
			subclass="mastertabcontrol content">
		<t:tab id="details" title="Details">
			<div>
			<table class="fullform" style="height: auto;">
			<tr>
				<th class="itemstatus"></th>
				<td style="padding: 0px;">
					<tbl:toolbar subclass="bottomborder bg-filled-50">
						<tbl:button 
							id="btnEdit"
							disabled="<%=!writePermission%>" 
							image="edit.png" 
							title="Edit&hellip;" 
							tooltip="<%=writePermission ? "Edit this item" : "You do not have permission to edit this item"%>" 
						/>
						<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
							wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
						<tbl:button
							image="help.png"
							subclass="auto-init"
							data-auto-init="help"
							data-help-id="diskusage.details"
							title="Help&hellip;"
							tooltip="Get help about this page"
						/>
					</tbl:toolbar>
				</td>
			</tr>
			</table>
			<table style="width: 100%; height: 8em;" class="bottomborder">
			<tr valign="top">
				<td style="width: 50%; height: 100%;">
					<%
					if (user != null)
					{
						%>
						<table class="fullform">
						<tr>
							<th>Name</th>
							<td><%=Base.getLinkedName(ID, user, false, true)%></td>
						</tr>
						<tr>
							<th>Quota</th>
							<td><base:propertyvalue item="<%=user%>" property="quota" /></td>
						</tr>
						<tr>
							<th>Quota group</th>
							<td><base:propertyvalue item="<%=user%>" property="quotaGroup" /></td>
						</tr>
						<tr class="dynamic">
							<th>Description</th>
							<td><%=HTML.niceFormat(user.getDescription())%></td>
						</tr>
						</table>
						<%
					}
					else if (group != null)
					{
						%>
						<table class="fullform">
						<tr>
							<th>Name</th>
							<td><%=Base.getLinkedName(ID, group, false, true)%></td>
						</tr>
						<tr>
							<th>Quota</th>
							<td><base:propertyvalue item="<%=group%>" property="quota" /></td>
						</tr>
						<tr class="dynamic">
							<th>Description</th>
							<td><%=HTML.niceFormat(group.getDescription())%></td>
						</tr>
						</table>
						<%
					}
					%>
				</td>
				<td style="width: 50%; height: 100%;" class="leftborder">
					<table class="special fullform">
					<tr>
						<th style="width: 10em;"></th>
						<th style="width: 12em;">Total</td>
						<th style="width: 12em;">Primary</td>
						<th style="width: 12em;">Secondary</td>
						<th style="width: 12em;">Offline</td>
						<th style="width: 12em;">External</td>
					</tr>
					<tr style="border-top-width: 1px;" class="highlight">
						<th>Total</th>
						<td><%=Values.formatBytes(summary.getTotal())%></td>
						<td><%=Values.formatBytes(summary.getTotal(Location.PRIMARY))%></td>
						<td><%=Values.formatBytes(summary.getTotal(Location.SECONDARY))%></td>
						<td><%=Values.formatBytes(summary.getTotal(Location.OFFLINE))%></td>			
						<td><%=Values.formatBytes(summary.getTotal(Location.EXTERNAL))%></td>			
					</tr>
					<%
					for (QuotaType qt : quotaTypes)
					{
						%>
						<tr class="highlight">
							<th><%=HTML.encodeTags(qt.getName())%></th>
							<td><%=Values.formatBytes(summary.getTotal(qt))%></td>
							<td><%=Values.formatBytes(summary.getTotal(qt, Location.PRIMARY))%></td>
							<td><%=qt.hasSecondaryLocation() ? Values.formatBytes(summary.getTotal(qt, Location.SECONDARY)) : "n/a"%></td>
							<td><%=qt.getSystemId().equals(QuotaType.FILE) ? Values.formatBytes(summary.getTotal(qt, Location.OFFLINE)) : "n/a"%></td>
							<td><%=qt.getSystemId().equals(QuotaType.FILE) ? Values.formatBytes(summary.getTotal(qt, Location.EXTERNAL)) : "n/a"%></td>
						</tr>
						<%
					}
					%>
					</table>
				</td>
			</tr>
			</table>
			</div>
		
		<base:section id="itemsSection" 
			title="<%="Disk consuming items (" + totalCount + ")"%>" 
			context="<%=cc%>">
			<tbl:table 
				id="items" 
				columns="<%=cc.getSetting("columns")%>"
				sortby="<%=cc.getSortProperty()%>" 
				direction="<%=cc.getSortDirection()%>"
				action="index.jsp"
				sc="<%=sc%>"
				item="<%=itemType%>"
				subcontext="<%=subContext%>"
				>
				<tbl:hidden
					name="item_type"
					value="<%=itemType.name()%>"
				/>
				<tbl:columndef
					id="type"
					property="itemType"
					datatype="int"
					title="Item type"
					enumeration="<%=itemTypes%>"
					filterable="true"
					sortable="true"
					show="always"
				/>
				<tbl:columndef 
					id="name"
					title="Name"
					show="always" 
				/>
				<tbl:columndef 
					id="bytes"
					property="bytes"
					datatype="long"
					title="Bytes"
					sortable="true"
					filterable="true"
					exportable="true"
					unit="<%=bytes%>"
				/>
				<tbl:columndef 
					id="location"
					property="location"
					datatype="int"
					title="Location"
					enumeration="<%=locations%>"
					filterable="true"
					sortable="true"
				/>
				<tbl:columndef 
					id="owner"
					property="user.name"
					datatype="string"
					title="Owner"
					sortable="true" 
					filterable="true"
					exportable="true"
				/>
				<tbl:columndef 
					id="group"
					property="group.name"
					datatype="string"
					title="Group"
					sortable="true" 
					filterable="true"
					exportable="true"
				/>
				<tbl:columndef 
					id="description"
					title="Description"
				/>
				<div class="panelgroup topborder leftborder rightborder bg-filled-50">
					<tbl:toolbar subclass="bottomborder">
						<tbl:button 
							id="btnDeleteItems"
							image="delete.png"
							title="Delete" 
							tooltip="Mark the selected items for deletion" 
							disabled="<%=totalCount <= 0%>"
						/>
						<tbl:button 
							id="btnRestoreItems"
							image="restore.png"
							title="Restore" 
							tooltip="Restore the selected items"
							disabled="<%=totalCount <= 0%>"
						/>
						<tbl:button 
							id="btnShareItems"
							image="share.png"
							title="Share&hellip;" 
							tooltip="Share the selected items"
							disabled="<%=totalCount <= 0%>"
						/>
						<tbl:button 
							id="btnColumns"
							image="columns.png" 
							title="Columns&hellip;" 
							tooltip="Show, hide and re-order columns" 
						/>
					</tbl:toolbar>
					<tbl:panel>
						<tbl:presetselector
							disableremoved="true"
						/>
						<tbl:navigator
							page="<%=cc.getPage()%>" 
							rowsperpage="<%=cc.getRowsPerPage()%>" 
							totalrows="<%=totalCount%>"
						/>
					</tbl:panel>
				</div>
				<tbl:data>
					<tbl:headers>
						<tbl:headerrow>
							<tbl:header colspan="3" />
							<tbl:columnheaders />
						</tbl:headerrow>
						<tbl:headerrow>
							<tbl:header subclass="index" />
							<tbl:header 
								subclass="check"
								><base:icon 
									id="check.uncheck"
									image="check_uncheck.png" 
									tooltip="Check/uncheck all" 
									 
								/></tbl:header>
							<tbl:header 
								subclass="icons" 
								/>
							<tbl:propertyfilter />
						</tbl:headerrow>
					</tbl:headers>
					<tbl:rows>
					<%
					if (cc.getMessage() != null)
					{
						%>
						<tbl:panel subclass="bg-filled-50">
							<div class="messagecontainer error"><%=HTML.encodeTags(cc.getMessage())%></div>
						</tbl:panel>
						<%
						cc.setMessage(null);
					}
					int index = cc.getPage()*cc.getRowsPerPage();
					if (diskUsage != null)
					{
						while (diskUsage.hasNext())
						{
							DiskUsage du = diskUsage.next();
							DiskConsumable item = null;
							boolean hasReadPermission = true;
							boolean hasWritePermission = false;
							boolean isRemoved = false;
							int consumableId = 0;
							try
							{
								item = du.getItem();
								consumableId = item.getId();
								hasWritePermission = item.hasPermission(Permission.WRITE);
							}
							catch (PermissionDeniedException ex)
							{
								hasReadPermission = false;
							}
							String name = "";
							String description = "";
							if (item instanceof File)
							{
								File file = (File)item;
								name = file.getPath().toString();
								description = file.getDescription();
							}
							else if (item instanceof Nameable)
							{
								Nameable nameable = (Nameable)item;
								name = nameable.getName();
								description = nameable.getDescription();
							}
							else if (item != null)
							{
								name = item.toString();
							}
							if (item instanceof Removable)
							{
								isRemoved = ((Removable)item).isRemoved();
							}
							String link = hasReadPermission ? 
								Base.getLink(ID, HTML.encodeTags(name), du.getItemType(), 
								consumableId, hasWritePermission) : "<i>- denied -</i>";
							index++;
							numListed++;
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="check" 
									><input 
										type="checkbox" 
										name="item:<%=du.getItemType().name()%>" 
										value="<%=consumableId%>"
									></tbl:header>
								<tbl:header 
									clazz="icons" 
									><base:icon 
										image="deleted.png" 
										tooltip="This item has been marked for deletion" 
										visible="<%=isRemoved%>"
									/>&nbsp;</tbl:header>
								<tbl:cell column="type"><%=du.getItemType()%></tbl:cell>
								<tbl:cell column="name"><%=link%></tbl:cell>
								<tbl:cell column="bytes"><%=Values.formatBytes(du.getBytes())%></tbl:cell>
								<tbl:cell column="location"><%=du.getLocation()%></tbl:cell>
								<tbl:cell column="owner"><base:propertyvalue item="<%=du%>" property="user" /></tbl:cell>
								<tbl:cell column="group"><base:propertyvalue item="<%=du%>" property="group" /></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(description)%></tbl:cell>
							</tbl:row>
							<%
							}
						}
						if (numListed == 0)
						{
							%>
							<tbl:panel subclass="bg-filled-50">
								<div class="messagecontainer note">
								<%=totalCount == 0 ? "No items were found" : "No items on this page. Please select another page!" %>
								</div>
							</tbl:panel>
							<%
						}
					%>
					</tbl:rows>
				</tbl:data>
			</tbl:table>
			</base:section>
		</t:tab>
		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
