/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2013 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/

var ScanResults = function()
{
	var results = {};
	
	/**
		Initialize the page.
	*/
	results.initDetails = function(element, autoInit)
	{
		if (autoInit == 'details')
		{
			Events.addEventHandler(element, 'click', results.toggleDetails);
		}
	}
	Doc.addElementInitializer(results.initDetails);
	
	results.initPage = function()
	{
		Buttons.addClickHandler('close', App.closeWindow);
	}
	
	results.toggleDetails = function(event)
	{
		var target = event.currentTarget;
		var detailsId = Data.get(target, 'details-id');
		Doc.showHide('details.' + detailsId);
		var icon = Doc.element('icon.'+detailsId).firstChild;
		if (icon)
		{
			if (icon.src.indexOf('right') > 0)
			{
				icon.src = icon.src.replace('right', 'down');
			}
			else
			{
				icon.src = icon.src.replace('down', 'right');
			}	
		}
	}	

	return results;
}();

Doc.onLoad(ScanResults.initPage);
