<%-- $Id: options.jsp 6661 2014-12-10 13:23:13Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2009 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Presets"
	import="net.sf.basedb.core.Presets.Preset"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.overview.GenericOverview"
	import="net.sf.basedb.util.overview.OverviewUtil"
	import="net.sf.basedb.util.overview.Node"
	import="net.sf.basedb.util.overview.ValidationOptions"
	import="net.sf.basedb.util.overview.Severity"
	import="net.sf.basedb.util.overview.Validator"
	import="net.sf.basedb.util.overview.extensions.ValidationRuleAction"
	import="java.util.List"
	import="java.util.Map"
	import="java.util.Iterator"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String presetName = Values.getStringOrNull(request.getParameter("presetName"));
final boolean resetToDefault = Values.getBoolean(request.getParameter("resetToDefault"));
final DbControl dc = sc.newDbControl();
try
{
	GenericOverview overview = OverviewUtil.getCurrentOverview(sc);
	Presets presets = OverviewUtil.getValidationPresets(sc);
	ValidationOptions options = null;
	if (resetToDefault)
	{
		options = new ValidationOptions();
	}
	else if (presetName == null)
	{
		options = new ValidationOptions(presets.getDefault());
	}
	else
	{
		options = new ValidationOptions(presets.getPreset(presetName));
	}
	Map<String, List<ValidationRuleAction>> validators = OverviewUtil.getAllRules(dc, overview);
	%>
	<base:page title="Validation options" type="popup">
	<base:head scripts="~options.js">
	<style>
	
	table.special
	{}
	
	table.special > tbody > tr > th
	{
		width: 17em;
		max-width: 17em;
	}
	
	.special select
	{
		min-width: 14em;
	}
	
	.selector
	{
		padding: 2px;
		border-radius: 4px;
	}
	
	.selector:hover
	{
		cursor: pointer;
		border-width: 2px;
		padding: 0;
	}
	
	.validatordescription
	{
		display: none;
		position: fixed;
		top: 5em;
		right: 1em;
		height: 10em;
		width: 18em;
	}
	tr:hover .validatordescription
	{
		display: block;
	}
	</style>
	</base:head>
		<base:body>
		<h1>Validation options <base:help helpid="item.overview.validationoptions" /></h1>
		
		<form name="options" action="index.jsp" method="post">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="cmd" value="SaveValidationOptions">
		
		<div class="content bottomborder">
		
			<div class="absolutefull" style="top: 0px; height: 3em;">
				<table class="fullform special">
				<tr>
					<th>Presets</th>
					<td>
						<table>
						<tr>
						<td>
							<select name="presets" id="presets" class="selectionlist">
								<option value="" <%="".equals(presetName) ? "selected" : "" %>>
								<option value="---" class="selectoptionheader" disabled>-- predefined --
								<option value="">BASE default
								<option value="---" class="selectoptionheader" disabled>-- user defined --
								<%
								for (Preset preset : presets)
								{
									String name = HTML.encodeTags(preset.getName());
									String selected = presetName != null && presetName.equals(preset.getName()) ?
										"selected" : "";
									%>
									<option value="<%=name%>" <%=selected%>><%=name%>
									<%					
								}
								%>
							</select>
						</td>
						<td>
							<base:buttongroup>
								<base:button id="btnSaveAsPreset" title="Save as&hellip;" />
								<base:button id="btnRemovePreset" title="Remove&hellip;" />
							</base:buttongroup>
						</td>
						</tr>
						</table>
					</td>
				</tr>
				</table>
			
			</div>
		
			<div class="absolutefull topborder" style="top: 3em; bottom: 0px;">
				<table class="fullform special">
				<%
				int grp = 0;
				StringBuilder descriptions = new StringBuilder();
				for (Map.Entry<String, List<ValidationRuleAction>> entry : validators.entrySet())
				{
					String title = entry.getKey();
					++grp;
					int vld = 0;
					%>
					<tr id="grp.<%=grp%>">
						<th>
							<div class="selector interactable auto-init" data-auto-init="group-toggle" data-group-id="<%=grp%>"
								><base:icon id="<%="grp."+grp+".icon"%>" image="move_right.png" /><%=HTML.encodeTags(title)%></div>
						</th>
						<td>
							<select name="setall.<%=grp%>" class="auto-init" data-auto-init="group-severity" data-group-id="<%=grp%>">
							<option value="">- set all in this group -
							<%
							for (Severity s : Severity.values())
							{
								%>
								<option value="<%=s.name()%>"><%=s%>
								<%
							}
							%>
							</select>
						</td>
					</tr>
					<%
					Iterator<ValidationRuleAction> vi = entry.getValue().iterator();
					while (vi.hasNext())
					{
						ValidationRuleAction validator = vi.next();
						++vld;
						Severity option = options.getSeverity(validator);
						String validatorId = validator.getId();
						boolean hasNext = vi.hasNext();
						%>
						<tr id="vld.<%=grp%>.<%=vld%>" style="display: none;" class="highlight">
							<th class="subprompt"><%=HTML.encodeTags(validator.getTitle())%></th>
							<td>
								<select id="select.<%=grp%>.<%=vld%>" name="<%=validatorId%>">
									<%
									for (Severity s : Severity.values())
									{
										%>
										<option value="<%=s.name()%>" <%=s == option ? "selected" : "" %>><%=s%>
										<%
									}
									%>
								</select>
								<%
								if (validator == Validator.NONMATCHING_SPOTCOUNT)
								{
									%>
									Threshold:
									<input type="text" class="text" 
										name="threshold" 
										title="Threshold, as a percentage or an absolute value" 
										size="8"
										value="<%=HTML.encodeTags(options.getOption(validator, "threshold", "5%"))%>" >
									<%
								}
								%>
								<div id="description.<%=validatorId%>" 
									class="validatordescription messagecontainer help"><%=HTML.encodeTags(validator.getDescription())%></div>
							</td>
						</tr>
						<%
					}
				}
				%>
				<tr class="dynamic">
					<th></th>
					<td></td>
				</tr>
				</table>
				
			</div>
		</div>
		</form>
		
		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
		
		</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
