<%-- $Id: jep_intensity_transformer.jsp 6320 2013-09-11 08:34:34Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006, 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@page import="org.json.simple.JSONArray"%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.Formula"
	import="net.sf.basedb.core.IntensityTransform"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.PluginConfigurationRequest"
	import="net.sf.basedb.core.RequestInformation"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = sc.getCurrentContext(Item.BIOASSAYSET);
DbControl dc = null;
try
{
	String errorMessage = (String)sc.getSessionSetting("plugin.configure.errors.message");
	List<Throwable> errors = (List<Throwable>)sc.getSessionSetting("plugin.configure.errors.list");
	
	PluginConfigurationRequest pcRequest = (PluginConfigurationRequest)sc.getSessionSetting("plugin.configure.request");
	RequestInformation info = pcRequest.getRequestInformation();
	
	dc = sc.newDbControl();
	Job job = (Job)sc.getSessionSetting("plugin.configure.job");
	dc.reattachItem(job, false);
	BioAssaySet source = null;
	source = (BioAssaySet)job.getParameterValue("source");
	if (source == null && cc.getId() != 0) source = BioAssaySet.getById(dc, cc.getId());
	if (source == null) throw new WebException("popup", "No current bioassay set", 
		"Could not find any current bioassay set. Please select a bioassay set before trying again");
	source = BioAssaySet.getById(dc, source.getId());
	int maxRawMappings = source.getMaxRawMappingsForSpot();

	RawDataType rdt = source.getRawDataType();
	
	// Current parameter values
	String childName = Values.getString((String)job.getParameterValue("childName"), source.getName());
	String childDescription = (String)job.getParameterValue("childDescription");
	String transformationName = (String)job.getParameterValue("transformationName");
	
	// Predefined formulas
	ItemQuery<Formula> formulaQuery = Formula.getQuery(Formula.Type.INTENSITY_TRANSFORMATION, rdt,
			source.getIntensityTransform());
	formulaQuery.order(Orders.asc(Hql.property("name")));
	formulaQuery.include(Include.MINE, Include.SHARED, Include.IN_PROJECT, Include.OTHERS);
	ItemResultList<Formula> formulas = formulaQuery.list(dc);
	%>
	<base:page type="popup" title="Transform intensities">
	<base:head scripts="/plugins/net/sf/basedb/plugins/jep_plugins.js,/plugins/net/sf/basedb/plugins/jep_intensity_transformer.js" />
	<base:body>
		<h1>Transform intensities <base:help helpid="jepintensitytransformer.options"/></h1>
		<div id="page-data" class="datacontainer"
			data-max-raw-mapping="<%=maxRawMappings %>"
			data-num-channels="<%=rdt.getChannels() %>"
		></div>
		<form name="transformation" action="index.jsp" method="post">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="requestId" value="<%=request.getParameter("requestId")%>">
		<input type="hidden" name="cmd" value="SetParameters">
		<input type="hidden" name="parameter:source" value="<%=source.getId()%>">
		
		<div class="content bottomborder">
			<table class="fullform input100">
			<%
			if (errorMessage != null || (errors != null && errors.size() > 0))
			{
				%>
				<tr>
					<th></th>
					<td colspan="2">
					<div id="errors" style="margin-bottom: 12px;">
						<div class="messagecontainer error" style="margin: 0px;">
						<%=errorMessage %>
						<%
						if (errors != null && errors.size() > 0)
						{
							%>
							<div id="showerrorlist">
								<base:icon 
									id="btnShowError"
									image="gonext.png" 
									style="color: #FFFFFF;"
									tooltip="Show more information about the error"
								/>
							</div>
							<div id="errorlist" style="display: none; margin: 0px;">
								<base:icon 
									id="btnHideError"
									image="move_down.png" 
									style="color: #FFFFFF;" 
									tooltip="Show less information"
								/>
								<ol>
								<%
								for (Throwable t : errors)
								{
									%>
									<li><%=t.getMessage()%>
									<%
								}
								%>
								</ol>
							</div>
							<%
						}
						%>
					</div>
					</td>
				</tr>
				<%
			}
			%>
			<tr>
				<th>Source bioassay set</th>
				<td><%=HTML.encodeTags(source.getName())%></td>
				<td></td>
			</tr>			
			<tr>
				<th>Child bioassay set</th>
				<td></td>
				<td></td>
			</tr>
			<tr>
				<th class="subprompt">Name</th>
				<td>
					<input type="text" class="text required" maxlength="255" name="parameter:childName" 
						value="<%=HTML.encodeTags(childName)%>"></td>
				<td></td>
			</tr>
			<tr class="big">
				<th class="subprompt">Description</th>
				<td>
					<textarea class="text" rows="6" name="parameter:childDescription" id="childDescription"
						><%=HTML.encodeTags(childDescription)%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="childDescription" title="Description" />
				</td>
			</tr>
			<tr>
				<th>Transformation</th>
				<td>
				<%
				if (formulas.size() > 0)
				{
					%>
					<select name="presets" id="presets" style="width: 32em;"
						>
						<option value="">- select from list or enter formula below -
						<%
						for (Formula f : formulas)
						{
							boolean ok = true;
							if (maxRawMappings != 1)
							{
								for (String formula : f.getFormulas())
								{
									ok &= !formula.contains("raw(");
								}
							}
							if (ok)
							{
								IntensityTransform result = f.getResultIntensityTransform();
								JSONArray jsonFormulas = new JSONArray();
								jsonFormulas.addAll(f.getFormulas());
								%>
								<option value="<%=f.getId()%>" title="<%=HTML.encodeTags(f.getDescription())%>"
									data-transform="<%=result == null ? "" : result.name() %>"
									data-formulas="<%=HTML.encodeTags(jsonFormulas.toJSONString()) %>"
									><%=HTML.encodeTags(f.getName())%>
								<%
							}
						}
						%>
					</select>
					<%
				}
				%>
				</td>
				<td></td>
			</tr>
			<tr>
				<th class="subprompt">Name</th>
				<td>
					<input type="text" class="text" maxlength="255" name="parameter:transformationName" 
						value="<%=HTML.encodeTags(transformationName)%>"></td>
				<td></td>
			</tr>
			<%
			for (int ch = 1; ch <= rdt.getChannels(); ++ch)
			{
				String inputName = "parameter:ch" + ch + ".expression";
				String value = (String)job.getParameterValue("ch"+ch+".expression");
				if (value == null) value = (String)info.getParameter("ch"+ch+".expression").getParameterType().getDefaultValue();
				%>
				<tr>
					<th class="subprompt">Ch <%=ch%></th>
					<td>
						<input type="text" class="text required" name="<%=inputName%>" id="<%=inputName%>"
							value="<%=HTML.encodeTags(value)%>">
					</td>
					<td style="width: 20px;">
						<base:icon 
							subclass="auto-init link"
							data-auto-init="expression-builder"
							data-formula-id="<%=inputName%>"
							data-title="<%="Ch " + ch+"Expression"%>"
							data-formula-type="INTENSITY_TRANSFORMATION"
							data-raw-data-type="<%=rdt.getId() %>"
							data-channels="<%=rdt.getChannels() %>"
							data-bioassayset="<%=source.getId() %>"
							image="expression_builder.png"
							tooltip="A simple utility for building expressions"
						/>
					</td>
				</tr>
				<%
			}
			%>
			<tr>
				<th class="subprompt">Resulting transform</th>
				<td>
					<input type="hidden" name="parameter:resultTransform:emptyIsNull" value="1" />
					<select name="parameter:resultTransform">
					<option value="">- same as source data -
					<%
					for (IntensityTransform t : IntensityTransform.values())
					{
						%>
						<option value="<%=t.name()%>"><%=t.toString()%>
						<%
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th></th>
				<td colspan="2"></td>
			</tr>
			</table>
		</div>
		</form>
	
		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnNext" title="Next" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}%>
